VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DrawClosedCurve"
   ClientHeight    =   3630
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4665
   LinkTopic       =   "Form1"
   ScaleHeight     =   3630
   ScaleWidth      =   4665
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtTension 
      Height          =   285
      Left            =   720
      TabIndex        =   1
      Text            =   "0.5"
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Tension"
      Height          =   195
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   570
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The points.
Private m_Pts() As PointF

' The index of the next point to define.
Private m_NumPoints As Integer
Private Sub Form_Load()
    m_NumPoints = 0
    Me.ScaleMode = vbPixels
End Sub


' Select a point.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        ' Start over.
        m_NumPoints = 0
    Else
        ' Get another point.
        ReDim Preserve m_Pts(0 To m_NumPoints)
        m_Pts(m_NumPoints).X = X
        m_Pts(m_NumPoints).Y = Y
        m_NumPoints = m_NumPoints + 1
    End If

    ' Redraw.
    Me.Refresh
End Sub


Private Sub Form_Paint()
Dim tension As Single
Dim i As Integer

    Cls
    If m_NumPoints >= 4 Then
        ' Draw the curve.
        tension = CSng(txtTension.Text)
        DrawClosedCurve Me, 0.01, tension, m_Pts
    End If

    ' Draw the control points.
    For i = 0 To m_NumPoints - 1
        Me.Line (m_Pts(i).X - 3, m_Pts(i).Y - 3)-Step(6, 6), vbWhite, BF
        Me.Line (m_Pts(i).X - 3, m_Pts(i).Y - 3)-Step(6, 6), vbBlack, B
    Next i
End Sub


